<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: Class Hierarchy</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Class Hierarchy</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock">
<p><a href="inherits.html">Go to the graphical class hierarchy</a></p>
This inheritance list is sorted roughly, but not completely, alphabetically:</div><div class="directory">
<div class="levels">[detail level <span onclick="javascript:toggleLevel(1);">1</span><span onclick="javascript:toggleLevel(2);">2</span><span onclick="javascript:toggleLevel(3);">3</span><span onclick="javascript:toggleLevel(4);">4</span><span onclick="javascript:toggleLevel(5);">5</span>]</div><table class="directory">
<tr id="row_0_" class="even"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_0_" class="arrow" onclick="toggleFolder('0_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCollisionVisitor.html" target="_self">CollisionVisitor</a></td><td class="desc">Abstract class of double dispatch visitor design patter </td></tr>
<tr id="row_0_0_"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCollisionBonus.html" target="_self">CollisionBonus</a></td><td class="desc">Resolves collision between <a class="el" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player.">Bonus</a> and other objects </td></tr>
<tr id="row_0_1_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCollisionEnemy.html" target="_self">CollisionEnemy</a></td><td class="desc">Resolves collision between <a class="el" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.">Enemy</a> and other objects </td></tr>
<tr id="row_0_2_"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCollisionPlayer.html" target="_self">CollisionPlayer</a></td><td class="desc">Resolves collision between <a class="el" href="classPlayer.html" title="Represent player, takes user input.">Player</a> and other objects </td></tr>
<tr id="row_0_3_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCollisionProjectile.html" target="_self">CollisionProjectile</a></td><td class="desc">Resolves collision between <a class="el" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites">Projectile</a> and other objects </td></tr>
<tr id="row_1_"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classGameScene.html" target="_self">GameScene</a></td><td class="desc">Mayer singlton class of <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>, keeps track of all GameObjects. Updates GameObjects, resolves collisions using <a class="el" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter.">CollisionVisitor</a> </td></tr>
<tr id="row_2_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classLevelManager.html" target="_self">LevelManager</a></td><td class="desc">Mayer singlton class of LevelMagager which manages loading of level and spawning enemies </td></tr>
<tr id="row_3_"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classMenu.html" target="_self">Menu</a></td><td class="desc"><a class="el" href="classMenu.html" title="Menu class for managing user input.">Menu</a> class for managing user input </td></tr>
<tr id="row_4_" class="even"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_4_" class="arrow" onclick="toggleFolder('4_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classObject.html" target="_self">Object</a></td><td class="desc">Abstract class that manages position, rendering of it self and allows for memory managment by <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a> </td></tr>
<tr id="row_4_0_"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span id="arr_4_0_" class="arrow" onclick="toggleFolder('4_0_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classGameObject.html" target="_self">GameObject</a></td><td class="desc">Abstract class that represents <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> with collision and movement properties </td></tr>
<tr id="row_4_0_0_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span id="arr_4_0_0_" class="arrow" onclick="toggleFolder('4_0_0_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classBonus.html" target="_self">Bonus</a></td><td class="desc">Abstract class representing bonuses that can be applied to <a class="el" href="classPlayer.html" title="Represent player, takes user input.">Player</a> </td></tr>
<tr id="row_4_0_0_0_"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCannonBonus.html" target="_self">CannonBonus</a></td><td class="desc"><a class="el" href="classCannon.html" title="Cannon slow firing high damage weapon.">Cannon</a> weapon bonus </td></tr>
<tr id="row_4_0_0_1_" class="even"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classHealBonus.html" target="_self">HealBonus</a></td><td class="desc">Health repairing bonus </td></tr>
<tr id="row_4_0_0_2_"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classMachineGunBonus.html" target="_self">MachineGunBonus</a></td><td class="desc"><a class="el" href="classMachineGun.html" title="MachineGun starter weapon with ability to bounce bullets off borders.">MachineGun</a> weapon bonus </td></tr>
<tr id="row_4_0_0_3_" class="even"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classRocketBonus.html" target="_self">RocketBonus</a></td><td class="desc"><a class="el" href="classRocketLauncher.html" title="RocketLauncher balanced weapon with direct fire.">RocketLauncher</a> weapon bonus </td></tr>
<tr id="row_4_0_1_"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span id="arr_4_0_1_" class="arrow" onclick="toggleFolder('4_0_1_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classEntity.html" target="_self">Entity</a></td><td class="desc">Abstract class representing GameObjects that have weapon and health </td></tr>
<tr id="row_4_0_1_0_" class="even"><td class="entry"><span style="width:48px;display:inline-block;">&#160;</span><span id="arr_4_0_1_0_" class="arrow" onclick="toggleFolder('4_0_1_0_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classEnemy.html" target="_self">Enemy</a></td><td class="desc">Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death </td></tr>
<tr id="row_4_0_1_0_0_"><td class="entry"><span style="width:80px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classBomber.html" target="_self">Bomber</a></td><td class="desc">Basic enemy with rocker launcher </td></tr>
<tr id="row_4_0_1_0_1_" class="even"><td class="entry"><span style="width:80px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCruiser.html" target="_self">Cruiser</a></td><td class="desc">High health high fire rate enemy, cannot move while firing has cooldown on fire </td></tr>
<tr id="row_4_0_1_0_2_"><td class="entry"><span style="width:80px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classDrone.html" target="_self">Drone</a></td><td class="desc">Fast low health enemy, bounces off borders </td></tr>
<tr id="row_4_0_1_0_3_" class="even"><td class="entry"><span style="width:80px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classFighter.html" target="_self">Fighter</a></td><td class="desc">Basic enemy with machinegun </td></tr>
<tr id="row_4_0_1_1_"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classPlayer.html" target="_self">Player</a></td><td class="desc">Represent player, takes user input </td></tr>
<tr id="row_4_0_2_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span id="arr_4_0_2_" class="arrow" onclick="toggleFolder('4_0_2_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classProjectile.html" target="_self">Projectile</a></td><td class="desc">Class representing projectiles with their own speed, damage and sprites </td></tr>
<tr id="row_4_0_2_0_"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classBullet.html" target="_self">Bullet</a></td><td class="desc"><a class="el" href="classBullet.html" title="Bullet projectile with ability to bounce off borders.">Bullet</a> projectile with ability to bounce off borders </td></tr>
<tr id="row_4_0_2_1_" class="even"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classMiniRocket.html" target="_self">MiniRocket</a></td><td class="desc"><a class="el" href="classMiniRocket.html" title="MiniRocket mini projectile supplementing Rocket projectile.">MiniRocket</a> mini projectile supplementing <a class="el" href="classRocket.html" title="Rocket projectile balanced big projectile.">Rocket</a> projectile </td></tr>
<tr id="row_4_0_2_2_"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classRocket.html" target="_self">Rocket</a></td><td class="desc"><a class="el" href="classRocket.html" title="Rocket projectile balanced big projectile.">Rocket</a> projectile balanced big projectile </td></tr>
<tr id="row_4_0_2_3_" class="even"><td class="entry"><span style="width:64px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classShell.html" target="_self">Shell</a></td><td class="desc"><a class="el" href="classCannon.html" title="Cannon slow firing high damage weapon.">Cannon</a> projectile fast and hard hitting </td></tr>
<tr id="row_5_"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classScoreManager.html" target="_self">ScoreManager</a></td><td class="desc">Mayer singlton class of <a class="el" href="classScoreManager.html" title="Mayer singlton class of ScoreManager which saves and loads scores.">ScoreManager</a> which saves and loads scores </td></tr>
<tr id="row_6_" class="even"><td class="entry"><span style="width:16px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="structSpawnData.html" target="_self">SpawnData</a></td><td class="desc">Struct to store data from level file </td></tr>
<tr id="row_7_"><td class="entry"><span style="width:0px;display:inline-block;">&#160;</span><span id="arr_7_" class="arrow" onclick="toggleFolder('7_')">&#9660;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classWeapon.html" target="_self">Weapon</a></td><td class="desc">Factory styled class for creating projectiles </td></tr>
<tr id="row_7_0_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classCannon.html" target="_self">Cannon</a></td><td class="desc"><a class="el" href="classCannon.html" title="Cannon slow firing high damage weapon.">Cannon</a> slow firing high damage weapon </td></tr>
<tr id="row_7_1_"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classMachineGun.html" target="_self">MachineGun</a></td><td class="desc"><a class="el" href="classMachineGun.html" title="MachineGun starter weapon with ability to bounce bullets off borders.">MachineGun</a> starter weapon with ability to bounce bullets off borders </td></tr>
<tr id="row_7_2_" class="even"><td class="entry"><span style="width:32px;display:inline-block;">&#160;</span><span class="icona"><span class="icon">C</span></span><a class="el" href="classRocketLauncher.html" target="_self">RocketLauncher</a></td><td class="desc"><a class="el" href="classRocketLauncher.html" title="RocketLauncher balanced weapon with direct fire.">RocketLauncher</a> balanced weapon with direct fire </td></tr>
</table>
</div><!-- directory -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
